"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _react = _interopRequireWildcard(require("react"));

var _reactSyntaxHighlighter = require("react-syntax-highlighter");

var _supportedLanguages = require("../supportedLanguages");

var _themeBuilder = require("../themes/themeBuilder");

var Code = function Code(_ref) {
  var _ref$language = _ref.language,
      language = _ref$language === void 0 ? 'text' : _ref$language,
      _ref$theme = _ref.theme,
      theme = _ref$theme === void 0 ? {} : _ref$theme,
      codeStyle = _ref.codeStyle,
      _ref$codeTagProps = _ref.codeTagProps,
      codeTagProps = _ref$codeTagProps === void 0 ? {} : _ref$codeTagProps,
      _ref$preTag = _ref.preTag,
      preTag = _ref$preTag === void 0 ? 'span' : _ref$preTag,
      testId = _ref.testId,
      text = _ref.text;

  var _applyTheme = (0, _themeBuilder.applyTheme)(theme),
      inlineCodeStyle = _applyTheme.inlineCodeStyle;

  var props = {
    language: (0, _supportedLanguages.normalizeLanguage)(language),
    PreTag: preTag,
    style: codeStyle || inlineCodeStyle,
    codeTagProps: codeTagProps
  };
  return /*#__PURE__*/_react.default.createElement(_reactSyntaxHighlighter.PrismAsyncLight, (0, _extends2.default)({
    "data-code-lang": language,
    "data-testid": testId
  }, props), text);
};

var _default = /*#__PURE__*/(0, _react.memo)(Code);

exports.default = _default;