import React, { ReactNode } from 'react';
import { applyTheme } from '../themes/themeBuilder';
import type { CommonCodeProps } from './types';
export interface CodeProps extends CommonCodeProps {
    /** The styles that will be used when prism highlighter has tokenised the output */
    codeStyle?: Partial<ReturnType<typeof applyTheme>['inlineCodeStyle']>;
    /** The props that will be spread into the `<code>` tag. Useful for styling/assigning classNames */
    codeTagProps?: {};
    /** The element or custom react component to use in place of the default span tag */
    preTag?: ReactNode | string;
}
declare const _default: React.MemoExoticComponent<({ language, theme, codeStyle, codeTagProps, preTag, testId, text, }: CodeProps) => JSX.Element>;
export default _default;
