/// <reference types="react" />
import type { ThemeProps } from '@atlaskit/theme/types';
import type { CodeBlockTheme } from '../themes/types';
import type { CommonCodeProps } from './types';
export interface CodeBlockProps extends CommonCodeProps {
    /**
     * A temporary prop to allow users to override theme styles
     * without losing the theme context
     **/
    themeOverride?: CodeBlockTheme | ThemeProps;
    /**
     * Lines to highlight comma delimited.
     * Example uses:
  
     * - To highlight one line `highlight="3"`
     * - To highlight a group of lines `highlight="1-5"`
     * - To highlight multiple groups `highlight="1-5,7,10,15-20"`
     */
    highlight?: string;
    /** Screen reader text for the start of a highlighted line */
    highlightedStartText?: string;
    /** Screen reader text for the end of a highlighted line  */
    highlightedEndText?: string;
}
declare const _default: import("react").MemoExoticComponent<({ showLineNumbers, language, theme, themeOverride, highlight, highlightedStartText, highlightedEndText, testId, text, }: CodeBlockProps) => JSX.Element>;
export default _default;
